#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <curl/curl.h>
#include "text.h"
#include "histogram.h"
#include "svg.h"
#include "procent.h"
using namespace std;
struct Input {
    vector<double> numbers;
    size_t number_count{};
    size_t bin_count{};
    size_t max_count{};
};
Input
input_data(istream& inn,bool prompt) {
    if(prompt== true)
    {
        Input in;
        cerr << "Enter number count: ";
        inn >> in.number_count;
        vector<double> numbers(in.number_count);
        in.numbers.resize(in.number_count);
        for (size_t i = 0; i < in.number_count; i++) {
            inn >> in.numbers[i];
        }
        size_t bin_count;
        cerr << "Enter bin count: ";
        inn >> in.bin_count;
        size_t max_count;
        in.max_count = 0;
        return in;
    }
    if(prompt==false)
    {
        Input in;
        inn >> in.number_count;
        vector<double> numbers(in.number_count);
        in.numbers.resize(in.number_count);
        for (size_t i = 0; i < in.number_count; i++) {
            inn >> in.numbers[i];
        }
        size_t bin_count;
        inn >> in.bin_count;
        size_t max_count;
        in.max_count = 0;
        return in;
    }
}
size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}
Input
download(const string& address) {
    stringstream buffer;
        CURL* curl = curl_easy_init();
        if(curl) {
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
            curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
            curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
            res = curl_easy_perform(curl);
            curl_easy_cleanup(curl);
            if (res!=0){
                cout<<res;
                exit(1);
                        }
                }
    curl_global_init(CURL_GLOBAL_ALL);
    return input_data(buffer, false);
}
int main(int argc, char* argv[])
{
    Input in;
    if(argc>1)
    {
        in = download(argv[1]);
    }else {
        in = input_data(cin, true);
    }
    curl_global_init(CURL_GLOBAL_ALL);
    //auto in = input_data(cin,true);

    auto bins = make_histogram(in.numbers, in.bin_count);
    auto max_count=bins[0];
    for(size_t x : bins){
        if (x > max_count)
        {
            max_count=x;
        }
    }
    //show_histogram_text(bins,in.bin_count,in.numbers,max_count);
    show_histogram_svg(bins, max_count);
    return 0;
}
